"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const context_js_1 = require("../context.js");
const Opacity = () => {
    const { handleOpacity, opacity, tinyColor, squareSize } = (0, context_js_1.usePicker)();
    const [dragging, setDragging] = (0, react_1.useState)(false);
    const { r, g, b } = tinyColor.toRgb();
    const bg = `linear-gradient(90deg, rgba(255,255,255,0) 0%, rgba(${r},${g},${b},.5) 100%)`;
    const stopDragging = () => {
        setDragging(false);
    };
    const handleDown = () => {
        setDragging(true);
    };
    const handleMove = (e) => {
        if (dragging) {
            handleOpacity(e);
        }
    };
    const handleClick = (e) => {
        if (!dragging) {
            handleOpacity(e);
        }
    };
    const left = squareSize - 18;
    (0, react_1.useEffect)(() => {
        const handleUp = () => {
            stopDragging();
        };
        window.addEventListener('mouseup', handleUp);
        return () => {
            window.removeEventListener('mouseup', handleUp);
        };
    }, []);
    return (react_1.default.createElement("div", { onMouseDown: handleDown, onMouseMove: (e) => handleMove(e), style: {
            height: 14,
            marginTop: 17,
            marginBottom: 4,
            cursor: 'ew-resize',
            position: 'relative',
        } },
        react_1.default.createElement("div", { style: checkerStyles }),
        react_1.default.createElement("div", { style: {
                left: left * opacity,
                top: -2,
                position: 'absolute',
                border: '2px solid white',
                borderRadius: '50%',
                boxShadow: '0px 0px 3px rgba(0,0,0,.5)',
                width: '18px',
                height: '18px',
                zIndex: 1000,
                transition: 'all 10ms linear',
            } }),
        react_1.default.createElement("div", { style: {
                background: bg,
                position: 'absolute',
                left: '0px',
                top: '0px',
                width: '100%',
                height: '100%',
                borderRadius: '10px',
            }, onClick: (e) => handleClick(e) })));
};
exports.default = Opacity;
const checkerStyles = {
    width: '100%',
    height: 14,
    background: `linear-gradient(45deg, rgba(0, 0, 0, 0.18) 25%, transparent 25%, transparent 75%, rgba(0, 0, 0, 0.18) 75%, rgba(0, 0, 0, 0.18) 0),
    linear-gradient(45deg, rgba(0, 0, 0, 0.18) 25%, transparent 25%, transparent 75%, rgba(0, 0, 0, 0.18) 75%, rgba(0, 0, 0, 0.18) 0), white`,
    backgroundRepeat: 'repeat, repeat',
    backgroundPosition: '0px 0, 7px 7px',
    WebkitTransformOrigin: '0 0 0',
    transformOrigin: '0 0 0',
    WebkitBackgroundOrigin: 'padding-box, padding-box',
    backgroundOrigin: 'padding-box, padding-box',
    WebkitBackgroundClip: 'border-box, border-box',
    backgroundClip: 'border-box, border-box',
    WebkitBackgroundSize: '14px 14px, 14px 14px',
    backgroundSize: '14px 14px, 14px 14px',
    webkitBoxShadow: 'none',
    boxShadow: 'none',
    textShadow: 'none',
    WebkitTransition: 'none',
    mozTransition: 'none',
    OTransition: 'none',
    transition: 'none',
    WebkitTransform: 'scaleX(1) scaleY(1) scaleZ(1)',
    transform: 'scaleX(1) scaleY(1) scaleZ(1)',
    borderRadius: '10px',
};
